--- src/filter.c.orig	2015-09-02 15:47:47.000000000 +0900
+++ src/filter.c	2015-10-23 03:44:52.608137000 +0900
@@ -35,6 +35,7 @@
 #include "epson-escpr-media.h"
 #include "epson-protocol.h"
 #include "epson-escpr-api.h"
+#include "epson-escpr-api-private.h"
 #include "epson-escpr-services.h"
 #include "epson-escpr-mem.h"
 
@@ -87,7 +88,7 @@
 #endif
 
 EPS_JOB_ATTRIB     jobAttr;
-void* context;
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////
 
 EPS_ERR_CODE epsInitLib(){
@@ -212,7 +213,6 @@
 	unsigned char *band;
 
 	long read_size = 0;
-	long read_page_no = 0;
 	int band_line;
 
 	int err = 0;
@@ -228,9 +228,7 @@
 	/* library options */
 	EPS_OPT printOpt;
 	EPS_BANDBMP bandBmp;
-
-	/* Fifo for Backend */
-	context = (void*)XFIFOOpen();
+	EPS_RECT bandRect;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////
 	memset (&jobAttr, 0, sizeof(jobAttr));
@@ -273,6 +271,7 @@
 	memset (&fopt, 0, sizeof (filter_option_t));
 	memset (&printOpt, 0, sizeof (EPS_OPT));
 	memset (&bandBmp, 0, sizeof(EPS_BANDBMP));
+	memset (&bandRect, 0, sizeof(EPS_RECT));
 
 	strncpy (fopt.model, argv[1], NAME_MAX);
 	for (i = 0; i < NAME_MAX - 1 && fopt.model[i] != '\0' ; i ++)
@@ -393,40 +392,50 @@
 
 	/* setup band struct */
 	bandBmp.widthBytes = WIDTH_BYTES (print_area_x * 3 * 8 );
+
 	band = (unsigned char *)mem_new (char, bandBmp.widthBytes * band_line);
 	memset (band, 0xff, bandBmp.widthBytes * band_line);
 	bandBmp.bits = band;
 
+	bandRect.left = 0;
+	bandRect.right = printJob.printableAreaWidth;
+	bandRect.top = 0;
+	bandRect.bottom = 0;
+
 	/* debug */
 	DEBUG_JOB_STRUCT (printJob);
 
 	x_mag = (double)print_area_x / width_pixel;
 	y_mag = (double)print_area_y / height_pixel;
 	band_line = 1;
- 	bytes_per_line = width_pixel * byte_par_pixel;
+ 	bytes_per_line = WIDTH_BYTES(width_pixel * byte_par_pixel * 8 );
 	debug_msg("bytes_per_line = %d\n", bytes_per_line);
 	image_raw = mem_new0 (char, bytes_per_line);
 
 	int page_count = 0;
 
-
-	char page_num;
-
-
-	while ((read_page_no = read (STDIN_FILENO, &page_num, 1)) > 0)  // 最初に page番号を読み込み
+	while ((read_size = read (STDIN_FILENO, image_raw, bytes_per_line)) > 0)
 	{
 		long x_count, y_count;
 		int band_line_count;
+#if (HAVE_PPM)
+		char ppmfilename[30];
+		FILE *fp;
+#endif
 		y_count = 0;
 		band_line_count = 0;
+		bandRect.top = 0;
 
-		if(page_num == 99){		
-			err = epsStartPage(NULL, 2);
-		}else{
-			err = epsStartPage(NULL, page_num);
-			page_num--;
-		}		
-
+		err = epsStartPage(NULL, 0);
+#if (HAVE_PPM)
+		sprintf(ppmfilename, "/tmp/px-b750f-page%d.ppm", page_count);
+		fp = fopen(ppmfilename, "w");
+		fprintf(fp, "P3\n");
+		fprintf(fp, "%d\n",bytes_per_line/byte_par_pixel);
+		fprintf(fp, "%d\n",(int)print_area_y);
+		fprintf(fp, "255\n");
+		fclose(fp);
+#endif
 		page_count++;
 		if (err)
 			err_fatal ("Error occurred in \"PINIT_FUNC\"."); /* exit */
@@ -499,20 +508,41 @@
 				band_line_count ++;
 				if (band_line_count >= band_line)
 				{
+					bandRect.bottom = bandRect.top + band_line_count;
 					printHeight = 1;
 					memcpy(pagebuf, bandBmp.bits, bandBmp.widthBytes);
+#if (HAVE_PPM)
+					fp = fopen(ppmfilename, "a+");
+					int i=0;	
+					for(i=0; i<bytes_per_line/byte_par_pixel*3; i++){		
+						fprintf(fp, "%u ", (unsigned char)pagebuf[i]);
+					}
+					fprintf(fp, "\n");
+					fclose(fp);
+#endif
 					pagebuf+= bandBmp.widthBytes;
 					posbuf+=bandBmp.widthBytes;
 
 					band_line_count -= printHeight;
 					bandBmp.bits += band_line_count;
 					
+					bandRect.top = bandRect.bottom;
 				}
 			}
 			if (band_line_count > 0)
 			{
+				bandRect.bottom = bandRect.top + band_line_count;
 				printHeight = 1;
 				memcpy(pagebuf, bandBmp.bits, bandBmp.widthBytes);
+#if (HAVE_PPM)
+				fp = fopen(ppmfilename, "a+");
+				int i=0;	
+				for(i=0; i<bytes_per_line/byte_par_pixel*3; i++){		
+					fprintf(fp, "%u ", (unsigned char)pagebuf[i]);
+				}
+				fprintf(fp, "\n");
+				fclose(fp);
+#endif
 				pagebuf+= bandBmp.widthBytes;
 				posbuf+= bandBmp.widthBytes;
 				band_line_count -= printHeight;
@@ -562,7 +592,7 @@
 			if(err)
 				err_fatal ("Error occurred in \"PEND_FUNC\".");	/* exit */
 		}
-		else //if(duplex)
+		else
 		{
 			for (i = 0; i < print_area_y; i ++)
 			{
@@ -652,6 +682,8 @@
 				
 				if (band_line_count >= band_line)
 				{
+					bandRect.bottom = bandRect.top + band_line_count;
+
 					printHeight = band_line_count;
 					PrintBand (bandBmp.bits, bandBmp.widthBytes, &printHeight);
 #if (HAVE_PPM)
@@ -667,13 +699,15 @@
 					debug_msg("widthByte = %d\n", bandBmp.widthBytes);
 					band_line_count -= printHeight;
 					bandBmp.bits += band_line_count;
+					bandRect.top = bandRect.bottom;
 				}
 				
 			}
 			
 			if (band_line_count > 0)
 			{
-			
+				bandRect.bottom = bandRect.top + band_line_count;
+				
 				err = PrintBand (bandBmp.bits, bandBmp.widthBytes, &printHeight);
 				debug_msg("printHeight = %d\n", printHeight);
 				if(err)
@@ -690,10 +724,8 @@
 				band_line_count -= printHeight;
 				bandBmp.bits += band_line_count;
 			}
-
-//			err = epsEndPage(page_num - 1);
-			err = epsEndPage(0);
-
+			
+			err = epsEndPage(FALSE);
 			if(err)
 				err_fatal ("Error occurred in \"PEND_FUNC\".");	/* exit */
 		}
@@ -716,9 +748,6 @@
 	mem_free(band);
 	mem_free(paper);
 	debug_msg("PRINT SUCCESS\n");
-
-	XFIFOClose(&context);
-
 	return 0;
 }
 
@@ -834,10 +863,6 @@
 	saturation = str_clone (filter_opt_p->saturation, strlen (filter_opt_p->saturation));
  	jobAttr.saturation =  atoi(saturation) * 2;
 
-	/* Get number of pages */
-	char page_num;
-	read (STDIN_FILENO, &page_num, 1);
-
 	/* Others */
 	jobAttr.apfAutoCorrect = EPS_APF_ACT_STANDARD;
 	jobAttr.sharpness = 0;
@@ -847,8 +872,7 @@
 	jobAttr.copies = 1;
 	jobAttr.feedDirection = EPS_FEEDDIR_PORTRAIT;      /* paper feed direction  hardcode */
 	jobAttr.printDirection = 0;
-	jobAttr.pageNum = page_num;
-	jobAttr.version = 4;
+
 
 	/* free alloced memory */
 	mem_free(mediaType);
@@ -878,15 +902,8 @@
 
 EPS_INT32 print_spool_fnc(void* hParam, const EPS_UINT8* pBuf, EPS_UINT32 cbBuf) 
 {
-#if 0
 	long int i;
 	for (i = 0; i < cbBuf; i++)
 		putc(*(pBuf + i), outfp);
-#endif
-
-//	fwrite (pBuf, cbBuf, 1, outfp);
-
-	XFIFOWrite(context, pBuf, cbBuf);
-
 	return 1;
 }
